/* Program ID:          tep_ask.c
 * Programmer Name:     Matt Phillips
 * Date Created:        February 17, 2001
 * Program Updated by:  Matt Phillips       Date of Update: 02/17/01
 * Program Description: tep_ask.c handles conversational answers to questions
 *						the player asks to game characters
 * Dependencies:        "tep_incs.h", tep_ask.h
 * Input Files:         N/A
 * Output Files:        N/A
 */
#include "tep_incs.h"



/* Function:            fnAsk
 * Parameters:          TepCurState *	pointer to the gamestate struct
 *						TepChar *		pointer to the character the player is talking too
 *						TepParse *		pointer to the command struct
 * Return Value:        0 (for now...)
 * Side Effects:        outputs the answer to a question
 * Description:         finds an answer to a question that was asked and prints the answer.
 *                      control loop. Before quitting cleans up all memory.
 */
BOOL fnAsk( TepCurState *pGameState, TepChar *pSpeaker, TepParse *pCmd )
{
	TepConvData *pAnswer = NULL;	/* this is a pointer to the answer to the question */

    /* interpret the command */
	if( pCmd->Char2 != PARSE_UNUSED )
	{
		/* WTF!?! HAPPENS IF YOU ASK THE CHARACTER ABOUT THEMSELVES? */
		/* if the character isn't dead... */
		if( fnTepCharSearch( pGameState->liveList, pCmd->Char2 ) != NULL )
		{
//			pAnswer = fnTepConvSearch(
		}
		else
		{
			/* we don't speak of the dead here */
		}
	}
	else if( pCmd->Reserved != PARSE_UNUSED )
	{
		/* it's a location - find the answer */
		/* is it a location that they frequent? */
	}
	else
	{
		/* what the hell is the player talking about */
	}
	/* output of pAnswer */
	return TRUE;
}
