#include "tep_incs.h"

TepChar *fnPickRandBadChar( TepCurState *pGameState )
{
    TepIDUnNode *pID = NULL;            /* pointer to a id list */
    int iCount, iRand;

    /* count the available murderers */
    pID = pGameState->killersList;
    for( iCount = 0; pID != NULL; iCount++, pID = pID->NEXT );

    /* pick a random murderer */
    /* fill iRand with an appropriate random value */
    iRand = rand() % iCount;

    /* pick the murderer... */
    pID = pGameState->killersList;
    for( iCount = 0; iCount < iRand; iCount++, pID = pID->NEXT );

    /* return the matching character pointer */
    return fnTepCharSearch( pGameState->liveList, pID->NODE );
}




TepChar *fnPickRandGoodChar( TepCurState *pGameState )
{
    TepChar *pChar = NULL;              /* pointer to a char list */
    TepChar *pGoodChar = NULL;          /* pointer to a good char */
    int iCount, iRand;

    /* count the available victims */
    pChar = pGameState->liveList;
    for( iCount = 0; pChar != NULL; iCount++, pChar = pChar->NEXT );

    /* pick a random victim - loop if the victim is one of the killers */
    do
    {
        /* fill iRand with an appropriate random value */
        iRand = rand() % iCount;

        /* pick the victim... */
        pChar = pGameState->liveList;
        for( iCount = 0; iCount < iRand; iCount++, pChar = pChar->NEXT );

        /* find the matching character */
        pGoodChar = fnTepCharSearch( pGameState->liveList, pChar->id );

    }while( fnTepIDSearch( pGameState->killersList, pGoodChar->id ) != NULL );

    /* return the character pointer */
    return pGoodChar;
}




