#include "RoomEdit.h"

/*Removes tabs and newlines*/
BOOL fnRemoveTabs(char *string)
{
	char *pString;
	pString = string;

	if(string == NULL)
		return FAILURE;

	while(*pString)
	{
		if(*pString == '\t')
		{
			*pString = '#';
		}
		if(*pString == '\n')
		{
			*pString = ' ';
		}
		pString++;
	}
	return SUCCESS;
}

/*writes a temp out file USED ONLY FOR DEBUGGING!!!!*/
BOOL fnWriteTempOutputFile(InputRoom *roomList)
{
	FILE *outFile;
	InputRoom *inputRoom;
	int i;

	outFile = fopen("tempRoomOutFile.txt", "a");
	if(outFile == NULL)
	{
		perror("Temp. out.");
		return FAILURE;
	}
	
	if(roomList == NULL)
		return FAILURE;

	for(inputRoom = roomList; inputRoom != NULL; inputRoom = inputRoom->NEXT)
	{
		fprintf(outFile, "tepid: %x\n", inputRoom->id);
		fprintf(outFile, "name: %s", inputRoom->name);
		fprintf(outFile, "type: %d\n", inputRoom->type);
		fprintf(outFile, "commands: %x\n", inputRoom->cmd.allCmd);
		fprintf(outFile, "people: ");
		for (i = 0; i < MAX_PEOPLE; i++)
		{
			fprintf(outFile, "%x ", inputRoom->people[i]);
		}
		fprintf(outFile, "\n");
		fprintf(outFile, "northlink: %x\n", inputRoom->rooms[0]);
		fprintf(outFile, "eastlink: %x\n", inputRoom->rooms[1]);
		fprintf(outFile, "southlink: %x\n", inputRoom->rooms[2]);
		fprintf(outFile, "westlink: %x\n", inputRoom->rooms[3]);
		fprintf(outFile, "objects: ");
		for(i = 0; i < MAX_OBJECTS; i++)
		{
			fprintf(outFile, "%x ", inputRoom->objs[i]);
		}
		fprintf(outFile, "\n");
		fprintf(outFile, "text: \n");
		fputs(inputRoom->desc, outFile);
		fprintf(outFile, "\n");
		fprintf(outFile, "%s\n",EOTMARKER);
	}
	fclose(outFile);
	return SUCCESS;
}


/*Initializes InputRooms*/
void fnInputRoomInitialize(InputRoom *inputRoom)
{
	int i;
	inputRoom->desc = NULL;
	inputRoom->id = 0;
	inputRoom->name[0] = 0;
	inputRoom->NEXT = NULL;
	for(i = 0; i < MAX_OBJECTS; i++)
		inputRoom->objs[i] = 0;
	inputRoom->dynOther[0] = 0;
	for(i = 0; i < MAX_PEOPLE; i++)
		inputRoom->people[i] = 0;
	for(i = 0; i < 4; i++)
		inputRoom->rooms[i] = 0;
	inputRoom->type = 0;
	inputRoom->cmd.allCmd = 0;
	inputRoom->cmd.Look = 1;
}

/*InputRoomAppending*/
BOOL fnInputRoomAppend(InputRoom **ppListRoot, InputRoom *inputRoom)
{
    InputRoom *pCurrNode = *ppListRoot;   /* point to the first item in the list or NULL */
    InputRoom *pNewNode;                  /* pointer to the newly created node */
	int i;

    /* allocate memory for the node */
    pNewNode = malloc(sizeof(InputRoom));

    /* if the malloc fails return failure */
    if(pNewNode == NULL)
    {
        return FAILURE;
    }

    /* if the memory was allocated successfully initialize the structs members */
    pNewNode->id = inputRoom->id;
	strcpy(pNewNode->name, inputRoom->name);
	pNewNode->type = inputRoom->type;
    pNewNode->NEXT = NULL;
	pNewNode->cmd = inputRoom->cmd;
	pNewNode->desc = calloc((strlen(inputRoom->desc) + 1), 1);
	strcpy(pNewNode->desc, inputRoom->desc);
	for(i = 0; i < MAX_OBJECTS; i++)
	{
		pNewNode->objs[i] = inputRoom->objs[i];
	}

	for(i = 0; i < MAX_PEOPLE; i++)
	{
		pNewNode->people[i] = inputRoom->people[i];
	}
	for(i = 0; i < 4; i++)
	{
		pNewNode->rooms[i] = inputRoom->rooms[i];
	}
	

    /* if there is no first item in the list... */
    if(*ppListRoot == NULL)
    {
        /* put the new node there */
        *ppListRoot = pNewNode;
    }
    else
    {
        /* else loop to the end of the list */
        while(pCurrNode->NEXT != NULL)
        {
            pCurrNode = pCurrNode->NEXT;
        }

        /* place the new node at the end */
        pCurrNode->NEXT = pNewNode;
    }

    return SUCCESS; /* YES! I won! */
}

/*Searching*/
InputRoom *fnInputRoomSearch(InputRoom *pRoomList, TepID searchID)
{
    InputRoom *pCurrNode;

    for(pCurrNode = pRoomList; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
    {
        if((pCurrNode->id) == searchID)
        {
            return pCurrNode;
        }
    }
    return NULL;
}

/*Initializes the object association kludge*/
void IDKludgeInit(IDKludge *idKludge)
{
	int i;

	idKludge->Room = 0;
	for(i = 0; i < MAX_OBJECTS; i++)
	{
		idKludge->Objects[i] = 0;
	}
	idKludge->counter = 0;

}

/*Dumps accumulated objects into the rooms and huts*/
BOOL fnFillRoomObjects(InputRoom **RoomList, IDKludge *RoomKludge)
{
	InputRoom	*inputRoom;
	int			i;

	if((inputRoom = fnInputRoomSearch(*RoomList, RoomKludge->Room)) == NULL)
	{
		return FAILURE;
	}
	for(i = 0; i < MAX_OBJECTS; i++)
	{
		inputRoom->objs[i] = RoomKludge->Objects[i];
	}
	IDKludgeInit(RoomKludge);
	return SUCCESS;
}

/*Reads the input file*/
BOOL ReadInputFile( InputRoom **RoomList)
{
	InputRoom	inputRoom;		/*Create an input room struct*/
	char		*desc;
	char		inString[SMALLBUFF] = {0};
	TepID		newID = 0;
	FILE		*input;
	IDKludge	RoomKludge;
	IDKludge	HutKludge;

	IDKludgeInit(&RoomKludge);
	IDKludgeInit(&HutKludge);


	/*initialize inputRoom*/
	fnInputRoomInitialize(&inputRoom);

	/*Open File*/
	input = fopen("roomInput.txt", "r");
	if(input == NULL)
	{
		perror("open");
		return FAILURE;
	}
	/*Read in a line from the file*/
	while(fgets(inString, SMALLBUFF, input) != NULL)
	{
		char field[50] = {0}, entry[MAX_NAME_LEN] = {0};
	
		sscanf(inString, "%s %s", field, entry);


		/*Store type in struct*/
		if(strcmp(field, "type:") == 0)
		{
			if(strcmp(entry, "room") == 0)
			{
				fnFillRoomObjects(RoomList, &RoomKludge);
				fnFillRoomObjects(RoomList, &HutKludge);
//				printf("found type: room\n");
				inputRoom.type = ROOM;

			}
			else if(strcmp(entry, "object") == 0)
			{
//				printf("found type: object\n");
				inputRoom.type = OBJECT;
			}
			else if(strcmp(entry, "hut") == 0)
			{
				fnFillRoomObjects(RoomList, &HutKludge);
//				printf("found type: hut\n");
				inputRoom.type = HUT;
				HutKludge.Room = 1;
			}
			else
			{
//				printf("type mistake");
				return FAILURE;
			}
		}
		/*Store name in struct*/
		else if(strcmp(field, "name:") == 0)
		{
//			printf("found name\n");

			strncpy(inputRoom.name, (inString + strlen(field)), MAX_NAME_LEN);
		}
		else if(strcmp(field, "tepid:") == 0)
		{

//			printf("found tepid\n");
//			inputRoom.id = atoi(entry);
			sscanf(inString,"%s%x", field, &inputRoom.id);


		}
		else if(strcmp(field, "northlink:") == 0)
		{
			
//			printf("found north link\n");
//			inputRoom.rooms[0] = atoi(entry);
			sscanf(inString,"%s%x", field, &inputRoom.rooms[0]);
			if(inputRoom.rooms[0] != 0)
				inputRoom.cmd.North = 1;
		}
		else if(strcmp(field, "eastlink:") == 0)
		{
//			printf("found east link\n");
//			inputRoom.rooms[1] = atoi(entry);
			sscanf(inString,"%s%x", field, &inputRoom.rooms[1]);
			if(inputRoom.rooms[1] != 0)
				inputRoom.cmd.East = 1;

		}
		else if(strcmp(field, "southlink:") == 0)
		{
//			printf("found south link\n");
//			inputRoom.rooms[2] = atoi(entry);
			sscanf(inString,"%s%x", field, &inputRoom.rooms[2]);
			if(inputRoom.rooms[2] != 0)
				inputRoom.cmd.South = 1;
		}
		else if(strcmp(field, "westlink:") == 0)
		{
//			printf("found west link\n");
//			inputRoom.rooms[3] = atoi(entry);
			sscanf(inString,"%s%x", field, &inputRoom.rooms[3]);
			if(inputRoom.rooms[3] != 0)
				inputRoom.cmd.West = 1;
		}
		/*Read in description This should be the last thing for a room record*/
		else if(strcmp(field, "text"))
		{
			char test[4] = {0};
			InputRoom *Check;
//			printf("found text\n");
			/*Allocate approx. 1 typed page worth of characters  for descriptions*/
			if((desc = calloc(BIGBUFF, 1)) == NULL)
			{
				perror("desc");
				return FAILURE;
			}

			while((fgets(inString, SMALLBUFF, input) != NULL))
			{
				if(strstr(inString, EOTMARKER) != NULL)
					break;
				strcat(desc, inString);
			}


//			printf("description: %s\n", desc);
			inputRoom.desc = desc;

			/* Compine id with the correct type and set appropriate commands*/
			if(inputRoom.type == OBJECT)
			{
				inputRoom.id |= ROOM_OBJ;
			}
			else
			{
				inputRoom.id |= ROOM_ROOM;
				inputRoom.cmd.Display = 1;
				inputRoom.cmd.Go = 1;
				inputRoom.cmd.Help = 1;
				inputRoom.cmd.Save = 1;
				inputRoom.cmd.Load = 1;
				inputRoom.cmd.Quit = 1;
			}
			if(inputRoom.type == HUT)
			{
				inputRoom.cmd.Leave = 1;
			}
			
			/*Search to see if id is already in use*/
			if((Check = fnInputRoomSearch(*RoomList, inputRoom.id)) != NULL)
			{
				printf("TepID of %s is already in use by %s", inputRoom.name, Check->name);

				getchar();
			}

			if(RoomKludge.Room == 0)
				RoomKludge.Room = inputRoom.id;
			else if (HutKludge.Room == 1)
			{
				HutKludge.Room = inputRoom.id;
				RoomKludge.Objects[RoomKludge.counter] = inputRoom.id;
				RoomKludge.counter++;
			}
			else
			{
			if((RoomKludge.Room != 0) && (HutKludge.Room == 0))
			{
				RoomKludge.Objects[RoomKludge.counter] = inputRoom.id;
				RoomKludge.counter++;
			}
			if((HutKludge.Room != 0) && (HutKludge.Room != 1))
			{
				HutKludge.Objects[HutKludge.counter] = inputRoom.id;
				HutKludge.counter++;
			}
			}

			fnInputRoomAppend(RoomList, &inputRoom);
			fnInputRoomInitialize(&inputRoom);
			free(desc);
		}

	}
	fclose(input);
	return SUCCESS;
}

/*Generates the game room list
NOTE: DON'T USE THIS ONE THERE IS A BETTER ONE BELOW*/
BOOL fnGenerateGameRoomList(InputRoom *roomList, TepRoom **TepRoomList)
{
	InputRoom	*pCurrentRoom = NULL;
	InputRoom	*pLinkedObject = NULL;
	TepIDUnNode	*rooms = NULL;
	TepIDUnNode *objects = NULL;
	int i;

	/*Create a list of rooms*/
	for(pCurrentRoom = roomList; pCurrentRoom != NULL; pCurrentRoom = pCurrentRoom->NEXT)
	{
		/*Create a rooms list*/
		for(i = 0; i < 4; i++)
		{
			if(pCurrentRoom->rooms[i] != 0)
				pCurrentRoom->rooms[i] |= ROOM_ROOM;
			fnTepIDAppend(&rooms, pCurrentRoom->rooms[i]);
		}
		/*Create objects list*/
		for(i = 0; pCurrentRoom->objs[i] != 0; i++)
		{
			fnTepIDAppend(&objects, pCurrentRoom->objs[i]);
		}
		/*Remove tabs and newlines*/
		fnRemoveTabs(pCurrentRoom->desc);
		fnRemoveTabs(pCurrentRoom->name);

		/*Create TepRoom List*/
		fnTepRoomAppend(TepRoomList, pCurrentRoom->id, pCurrentRoom->name,
			pCurrentRoom->desc, pCurrentRoom->cmd, rooms, objects);

		rooms = NULL;
		objects = NULL;
	}
	return SUCCESS;
}

/*Tests the Room Entry stuff*/
void TestRoomEdit(TepRoom *tepRoomList)
{
	TepIDUnNode	*rooms = NULL;
	TepIDUnNode	*objects = NULL;
	TepRoom		*pCurRoom = NULL;

	for(pCurRoom = tepRoomList; pCurRoom != NULL; pCurRoom = pCurRoom ->NEXT)
	{
		printf("Name: %s\nTepID: %x\nLinked Rooms:", pCurRoom->name, pCurRoom->id);
		for(rooms = pCurRoom->rooms; rooms != NULL; rooms = rooms->NEXT)
		{
			printf("\t%x", rooms->NODE);
		}
		printf("\nCommands: %x ", pCurRoom->cmd.allCmd);
		if(pCurRoom->cmd.Display == 1)
			printf(" Display");
		if(pCurRoom->cmd.East == 1)
			printf(" East");
		if(pCurRoom->cmd.Go == 1)
			printf(" Go");
		if(pCurRoom->cmd.Greet == 1)
			printf(" Greet");
		if(pCurRoom->cmd.Help == 1)
			printf(" Help");
		if(pCurRoom->cmd.Insult == 1)
			printf(" Insult");
		if(pCurRoom->cmd.Leave == 1)
			printf(" Leave");
		if(pCurRoom->cmd.Load == 1)
			printf(" Load");
		if(pCurRoom->cmd.Look == 1)
			printf(" Look");
		if(pCurRoom->cmd.North == 1)
			printf(" North");
		if(pCurRoom->cmd.Put == 1)
			printf(" Put");
		if(pCurRoom->cmd.Quit == 1)
			printf(" Quit");
		if(pCurRoom->cmd.Save == 1)
			printf(" Save");
		if(pCurRoom->cmd.South == 1)
			printf(" South");
		if(pCurRoom->cmd.Talk == 1)
			printf(" Talk");
		if(pCurRoom->cmd.West == 1)
			printf(" West");
		printf("\nObjects: ");
		for(objects = pCurRoom->objs; objects != NULL; objects = objects->NEXT)
		{
			printf(" %x", objects->NODE);
		}
//		printf("Description: %s\n", pCurRoom->desc);
		printf("\nDescription:\n");
		fnPrintOut(PAUSE, 1, pCurRoom->desc);
		printf("\n");
		getchar();
	}
}

/*Deleting input Rooms*/
BOOL fnInputRoomDelete(InputRoom **ppListRoot, InputRoom *pDeleteMe)
{
    InputRoom *pPrevNode, *pCurrNode;

    /* if there is no list... */
    if(*ppListRoot == NULL)
    {
        /* return failure, there's nothing to delete */
        return FAILURE;
    }
    /* if pDeleteMe is NULL then delete the entire list */
    else if(pDeleteMe == NULL)
    {
        while(*ppListRoot != NULL)
        {
            fnInputRoomDelete(ppListRoot, *ppListRoot);
        }
    }
    /* special check incase we need to delete the first item */
    else if(*ppListRoot == pDeleteMe)
    {
        /* close up the list around the dead node */
        *ppListRoot = pDeleteMe->NEXT;

        /* free the memory */
        free(pDeleteMe);

        /* this is a comment on success */
        return SUCCESS;
    }
    /* it's not the first element in the list so search for it */
    else
    {
        /* set pCurrNode to the beginning of the list */
        pCurrNode = *ppListRoot;

        /* loop through the list until we hit NULL */
        while(pCurrNode->NEXT != NULL)
        {
            /* increment the pointers */
            pPrevNode = pCurrNode;
            pCurrNode = pCurrNode->NEXT;

            /* is this the node we need to delete? */
            if(pCurrNode == pDeleteMe)
            {
                /* close up the list around the dead node */
                pPrevNode->NEXT = pCurrNode->NEXT;

                /* free the memory */
                free(pDeleteMe);

                /* this is a comment on success */
                return SUCCESS;
            }
        } /* end while */
    } /* end else - the catch all else */

    /* no match was found */
    return FAILURE;
}



/*This function excapsulates everything
	NOTE: THIS IS THE FUNCTION TO CALL FROM THE GAME
*/
BOOL CreateRoomList(TepRoom **TepRoomList)
{
	InputRoom	*roomList = NULL;

	if(ReadInputFile(&roomList) == FAILURE)
		return FAILURE;
	if(fnGenerateGameRoomList(roomList, TepRoomList) == FAILURE)
		return FAILURE;
	return fnInputRoomDelete(&roomList, NULL);
}


int main(void)
{
	TepRoom		*TepRoomList = NULL;

	CreateRoomList(&TepRoomList);
	TestRoomEdit(TepRoomList);
	fnTepRoomDelete(&TepRoomList, NULL);
	return 0;
}


