#include "tep_incs.h"
/*
SOMEBODY NEEDS TO TELL ME WHAT THE #DEF IS FOR A NEGATIVE REACTION TO A COMPLIMENT. I'M USING TALK_GENFAILURE FOR RIGHT
NOW.
*/

/********************************************************************************************/
/*TepChar List Functions*/

/*FUNCTION:		fnTepCharSearch
 *PARAMETERS:	TepChar					*pListRoot	Used as the starting point for the list search
 *				TepID					searchID	Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS:	None
 *DESCRIPTION:	This function searches for a node in the list corresponding to the given node pointer.

TepChar* fnTepCharSearch(TepChar *pListRoot, TepID searchID)
{
    TepChar *pCurrNode;

	for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
	{
		if((pCurrNode->id) == searchID)
		{
			return pCurrNode;
		}
	}

    return NULL;
}*/

/**** TEP CONV DATA *****************************/

/*FUNCTION:		fnTepConvDataSearch
 *PARAMETERS:	TepConvData				*pListRoot	Used as the starting point for the list search
 *				TepID					searchID	Search for this parameter
 *RETURN VALUE: Pointer to the node in the list that the search matches
 *SIDE EFFECTS:	None
 *DESCRIPTION:	This function searches for a node in the list corresponding to the given node pointer.

TepConvData *fnTepConvDataSearch(TepConvData *pListRoot, TepID searchID)
{
    TepConvData *pCurrNode;

	for(pCurrNode = pListRoot; pCurrNode != NULL; pCurrNode = pCurrNode->NEXT)
	{
		if((pCurrNode->id) == searchID)
		{
			return pCurrNode;
		}
	}
    return NULL;
}*/
/********************************************************************************************/
/* Programmer Name: Nathaniel Cleveland
 * Date Created: Feb 24th, 2001
 * Program Updated by:
 *
 * Program Description:			Called by talk to process compilements, makes sure we haven't reached our
 *								daily limit on sucking up, prints out conv strings accrodingly
 * Program dependacies:			fnTepConvDataSearch, fnTepCharSearch
 * Takes:						TepCurState *pGameState	today's gamestate
 *								TepID ID_Character, id of the character we need to deal with
 * Gives:						A boolean value,
 *								FAILURE means that we had an error somewhere
 *								SUCCES means that we kick some arse.
 *
 */
BOOL fnCompliment(TepCurState *pGameState, TepID ID_Character)
{
	TepChar		*pTep_Char = NULL;					/* The character being defamed */
	TepConvData *pTep_Conv = NULL;					/* pointer the the first possible response */

	/* Search for the character */
	pTep_Char = fnTepCharSearch(pGameState->liveList, ID_Character);

	/* check for failure of character search */
	if(pTep_Char == NULL)
	{
		return FAILURE;
	}

	/* see if we've reached our compliment level, if so print out one of the "yeah sure" convs */
	if(pTep_Char->complimentCounter < 1 )
	{
		/* Search for a character's over compliment reponses struct via pTep_Char */
		pTep_Conv = fnTepConvDataSearchRand(pTep_Char->conv, TEP_TALK | TALK_NEGATIVECOMPLIMENT, 0);

		/* error check, if null printout a generic answer */
		if(pTep_Conv == NULL)
		{
			fnPrintOut(NOPAUSE, NULL,NULL,1,"\nWhatever\n");
			return FAILURE;
		}/* end if */

		/* print out one of their responses for a negative reaction */
		fnPrintOut(NOPAUSE, NULL,NULL,1, pTep_Conv->details);

		/* I WON!!! */
		return SUCCESS;
	}/* end if */

	/* If we get here we know they can still be sucked up to, knock that suck up rating down one notch */
	pTep_Char->complimentCounter -= 1;

	/* Increment a character's liking of the player, make sure we don't go beyond the limit */
	if( (pTep_Char->like + LIKE_INCREMENT) > PLAYER_LIKE_MAX)
	{
		pTep_Char->like = PLAYER_LIKE_MAX;			/* set to the max so we don't over flow */
	}
	else
	{
		pTep_Char->like += LIKE_INCREMENT;			/* just go ahead and increment it */
	}

	/* Search for a character's compliment reponses struct via TepChar */
	pTep_Conv = fnTepConvDataSearchRand(pTep_Char->conv, TEP_TALK | TALK_POSITIVECOMPLIMENT, 0);

	/* check for failure of conv search, if failed prinout a generic response */
	if(pTep_Conv == NULL)
	{
		fnPrintOut(NOPAUSE, NULL,NULL,1,"\nThank you, Outsider, that is very kind.\n");
		return FAILURE;
	}

	/* print out one of their responses */
	fnPrintOut(NOPAUSE, NULL,NULL,1, pTep_Conv->details);

	return SUCCESS;
}

/*
int main(void)
{
	TepCurState GameState;
	TepID ID_Character = 0;
	char inputArray[255];

	while(1)
	{
		if(gets(inputArray) == NULL)
			break;

		if(inputArray == 0)
			break;

		fnCompliment(&GameState, ID_Character);

	}

	return 0;
}
*/
