#include "tep_incs.h"

/* Programmer Name: Nathaniel Cleveland
 * Date Created: Feb 4th, 2000
 * Program Updated by:
 *
 * Program Description:         Calls up list find to get the struct it wants, calls PrintOut to print it out.
 *
 * Program dependacies:         fnListFind, fnPrintOut, tep_incs.h
 * Takes:                       TepID ObjectID----The TepID of the object a player wants to look at.
 * Gives:                       TRUE for success
 */

BOOL fnExamineObject(TepCurState *pGameState, TepParse *Parse)
{
	TepDynRoom	*pDynRoom = NULL;
//	printf("Clue: %x\t Char1: %x\t Char2: %x\t Comm: %x\tRes: %x\t\n", Parse->Clue, Parse->Char1, Parse->Char2, Parse->Command, Parse->Reserved);

	/*Obtain access to the current dynamic room data*/
	pDynRoom = fnTepDynRoomSearch(pGameState->mapLite, pGameState->currentRoom->id);
	if(pDynRoom == NULL)
	{
		//printf("Error: Game map missing current room\n");
	}

        /* if we have a clue this will pass thru */
    if( (TEP_CLUE & Parse->Clue) == TEP_CLUE)
    {
        //TepClueData *pClueData;             /* pntr to a varible that point to the data we wish to print from  */
        TepIDUnNode *pClueID;
		TepClueData	*pClueData;

        /* search for the clue in the current Dynamic room*/
        if((pClueID = fnTepIDSearch(pDynRoom->objs, Parse->Clue)) != NULL)
		{
			/*Search for the clue in the current murder -> death -> clues list*/
			if((pClueData = fnClueDataSearch(pGameState->currentMurder->death->clues, pClueID->NODE, 0)) != NULL)
			{
				TepDataString *pMuder;//TepDataString *fnTepDataStringSearch(TepDataString *pListRoot, TepID searchID)
				
				if((pMuder = fnTepDataStringSearch(pGameState->keywords, pGameState->currentMurder->murderer)) == NULL)
				{
					pMuder->data = "<--Muderer-->";
					pMuder->id = pGameState->currentMurder->victim;
					pMuder->NEXT = NULL;
				}
				
				/* Once again i think we need a murderer here, and I'll list the clues name aswell */
				fnPrintOut(NOPAUSE, pClueData->keyword,pMuder->data,1, pClueData->details);
			}
			else
			{
				printf("That doesn't seem to be here.\n");
				return FALSE;
			}
		}
            /* call this to get my list, it'll return a -1 if it can't find it */
        else
        {
			/* Print out the bugger. */
            printf("I don't see that here.\n");
			return FALSE;
			//return;
        }

        /* then you must search through the clue list... which doesn't exist */
    }

        /* if we have a room this will pass thru */
    else if( ((TEP_ROOM | ROOM_OBJ) & Parse->Reserved) == (TEP_ROOM | ROOM_OBJ))
    {
			TepRoom *pRoomData;             /* pntr to a varible that point to the data we wish to print from  */

#if 1		/* bypassed by above */
            /* search for the room */
        if((fnTepIDSearch(pGameState->currentRoom->objs, Parse->Reserved) != NULL)  )
		{

			if( (pRoomData = fnTepRoomSearch(pGameState->FullMap, Parse->Reserved)) != NULL)
			{
				fnPrintOut(NOPAUSE, NULL,NULL,1, pRoomData->desc);
			}
		}
            /* call this to get my list, it'll return a -1 if it can't find it */
        else
        {
            printf("Sorry, I really don't see that anywhere.\n");
			return FALSE;
		//	return;
        }
#endif
            /* Print out the bugger. */
        
    }

	else if( (TEP_CHARACTER & Parse->Char1) == TEP_CHARACTER)
    {
        TepChar *pCharData;             /* pntr to a varible that point to the data we wish to print from  */
		TepIDUnNode *pCharClue;
		TepCurMurder	*pCurDeath = NULL;

            /* find my data, its all mine. MINE! */
        if(fnTepIDSearch(pDynRoom->people, Parse->Char1) != NULL)
		{
			if((pCharData = fnTepCharSearch(pGameState->liveList, Parse->Char1)) != NULL)
			{
				fnPrintOut(NOPAUSE, NULL,NULL,1, pCharData->desc);

				if( pCharData->clues != NULL )
				{
					/* find the current murder */
					for(pCurDeath = pGameState->currentMurder ;pCurDeath->NEXT != NULL ; pCurDeath = pCurDeath->NEXT );
				}


				for(pCharClue = pCharData->clues; pCharClue != NULL; pCharClue = pCharClue->NEXT )
				{					
					TepClueData*	ptepClueData = NULL;

					/*
					TepClueData		ErrorHack;
					char			ErrorHack2[10] = "\n@**&**@\n";

					printf("\n@**&**@\n");
					*/

					/* if it's a verbal clue we don't want to display it */
					if( !(pCharClue->NODE & CLUE_PERPVERBAL) )
					{
						/* find the related clue struct */
						if((ptepClueData = fnClueDataSearch(pCurDeath->death->clues, pCharClue->NODE, 0)) == NULL)
						{
							/*
							ptepClueData = &ErrorHack;
							ErrorHack.details = ErrorHack2;
							*/
							printf("Look could not find the character clue.\n");
						}
						else
						{
							fnPrintOut(NOPAUSE | CharGenderFind(pCharData->id), NULL, pCharData->name, 2, " #", ptepClueData->details);
						}
					}
				}/* end for */
			}/* end if */
		}/* end if */
        /* check for error */
        else if( fnTepCharSearch(pGameState->liveList, Parse->Char1) == NULL )
        {
			printf("The deceased no longer walk the island of Tep.\n");
			return FALSE;
        }
		else
		{
            printf("That person is not here.\n");
			return FALSE;
		}
        
    }/* end else if chain of stuff */
	else
	{
		printf("Sorry, I don't see that anywhere.\n");
		return FALSE;
	}

	/* added by nate to fix time issues 3/26/01 */
	pGameState->turnsLeft += ACT_LOOK;
	return TRUE;
}
