#include "tep_incs.h"


BOOL fnGameOver( TepCurState *pGameState, BOOL sCondition )
{
    TepConvData *pEOG_GenText = NULL;           /* pointer to the generic endgame text */
    TepConvData *pEOG_CharText = NULL;          /* pointer to a character's endgame text */

    TepChar *pSurvivor = NULL;                  /* pointer to a surviving character */

    /* if the player has won... */
    if( sCondition == PLAYER_WINS )
    {
        /* find the generic endgame intro text */
        if( ( pEOG_GenText = fnTepConvDataSearch( pGameState->genConv, TEP_TALK | TALK_EOGWININTRO, 0 ) ) != NULL )
		{
			/* display */
			fnPrintOut( PAUSE, NULL,NULL,1, pEOG_GenText->details );
		}

        /* pick a random survivor */
        pSurvivor = fnPickRandGoodChar( pGameState );
		if( pSurvivor != NULL )
		{
			fnPrintOut( NOPAUSE, NULL,NULL,3, "\n", pSurvivor->name, " approaches you:" ); 

			/* find the survivor's endgame speech */
			if( ( pEOG_CharText = fnTepConvDataSearch( pSurvivor->conv, TEP_TALK | TALK_EOGWINS, 0 ) ) != NULL )
			{
				/* display. Nate also added the first clue from the last murder and the last murderer */ 
				fnPrintOut( PAUSE, pGameState->currentMurder->death->clues->keyword,NULL,1, pEOG_CharText->details );
//				fnPrintOut( PAUSE, pGameState->currentMurder->death->clues->keyword,pGameState->currentMurder->murderer,1, pEOG_CharText->details );
			}
		}

		/* find the generic end game outro text */
		if( ( pEOG_GenText = fnTepConvDataSearch( pGameState->genConv, TEP_TALK | TALK_EOGWINOUTRO, 0 ) ) != NULL )
		{
			/* display */
			fnPrintOut( PAUSE, NULL,NULL,1, pEOG_GenText->details );
		}

    }
    /* if the player has lost... */
    else if( sCondition == PLAYER_LOSE )
    {
        /* find the generic endgame text */
        //pEOG_GenText = fnTepConvDataSearch( pGameState->genConv, TEP_TALK | TALK_EOGLOSE, 0 );

        /* pick a random survivor */
        pSurvivor = fnPickRandBadChar( pGameState );
		if( pSurvivor != NULL )
		{
			printf("\n\n");
			fnPrintOut( NOPAUSE, NULL,NULL,2, pSurvivor->name, " approaches you:" ); 

			/* find the survivor's endgame speech */
			if( ( pEOG_CharText = fnTepConvDataSearch( pSurvivor->conv, TEP_TALK | TALK_EOGLOSE, 0 ) ) != NULL )
			{
				/* display the endgame text */
				fnPrintOut( PAUSE, NULL,NULL,1, pEOG_CharText->details );
			}
		}
    }
    /* we got invalid data... */
    else
    {
        return FAILURE;
    }

    return SUCCESS;
}




BOOL fnGameOverCheck( TepCurState *pGameState )
{
	int iGoodCharTally, iEvilCharTally;
	TepIDUnNode *pEvilList = pGameState->killersList;
	TepChar		*pCharList = pGameState->liveList;

	/* tally the characters */
	for( iGoodCharTally = 0; pCharList != NULL; iGoodCharTally++, pCharList = pCharList->NEXT );
	
	/* adjust for Sheroesha */
	iGoodCharTally--;

	/* tally the killers */
	for( iEvilCharTally = 0; pEvilList != NULL; iEvilCharTally++, pEvilList = pEvilList->NEXT );

	/* subtract the evil from the good */
	iGoodCharTally -= iEvilCharTally;

	/* are we winning, losing or just moving on to another shitty day... */
	if( iEvilCharTally == 0 )
	{
		/* we won! */
		return PLAYER_WINS;
	}
	else if( iEvilCharTally >= iGoodCharTally )
	{
		/* we lost */
		return PLAYER_LOSE;
	}

	/* the fat lady hasn't sung yet */
	return PLAYER_CONT;
}