#define MAX_SAVE_GAMES 10
#define MAX_CHARACTERS_IN_GAME_FILENAME 13	/* this is for "tepsaveX.tsv"  plus the terminating NULL */
#define MAX_CHARACTERS_IN_GAME_NAME 48		/* this is for what the player will actually name a saved game file */
#define NUMBER_OF_CHUNKS 12					/* The number of different data types to be saved */
#define FORMATSPACING 55					/* The number of spaces guaranteed to separate each saved game's name and */



typedef BOOL (*SAVEFUNC)(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);		/* This enables my initialization of my jump table */
typedef BOOL (*LOADFUNC)(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);		/* This enables my initialization of my jump table */


/****************************************** Central FileManager Prototype *************************************************/
BOOL fnTepFileManage(TepCurState *gameState);
/*********************************************** EraseGame Prototype *************************************************/
BOOL fnEraseGame();

/*********************************************** SaveGame Prototypes *************************************************/
/* The save head honcho */
BOOL fnSaveGame(TepCurState *gameState);
/* This function will scan all ten .tsv files and display their filenames and times of saved; nicely formatted. */
BOOL fnScanSave(FILE **stream, char *fileName[MAX_SAVE_GAMES], int *fileSize);

/* This function is employed by every jump table function to print the standard header that precedes every subchunk of data. */
BOOL fnHeaderWrite(FILE *stream, char const iIdentifier[4], unsigned long iNumObjects, unsigned long *iFileOffset);

/* These are the functions that will make up my jump table */
BOOL fnSaveTPSV(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveNameOfFile(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveTimeOfSave(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveTULE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveCURM(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveKILS(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSavePADE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveLILT(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveNAME(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveEVAG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveEVGE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveOEVA(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveOEVG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveCUVI(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveCUMU(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveCUDE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveROID(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveROPE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnSaveROBJ(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);


/*********************************************** LoadGame Prototypes *************************************************/
/* The load head honcho */
BOOL fnLoadGame();

BOOL fnLoadTULE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadCURM(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadKILS(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadPADE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadLILT(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadNAME(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadEVAG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadEVGE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadOEVA(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadOEVG(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadCUVI(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadCUMU(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadCUDE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadROID(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadROPE(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);
BOOL fnLoadROBJ(FILE *stream, unsigned long *iFileOffset, TepCurState *gameState);

BOOL fnLoadStaticData( TepCurState *pGameState );
